#include "stm32f4xx.h" // Deklaration der Peripheriefunktionen

int factorial(int x)
{
	if(x < 0)
		throw 123;
	if(x <= 1)
		return 1;
	return x*factorial(x-1);
}

int main()
{
    RCC->AHB1ENR |= RCC_AHB1ENR_GPIODEN; // Clock fr Port D aktivieren
    GPIOD->MODER = 0x55000000; // Pin 12..15 als Ausgang deklarieren

	volatile int x = 5;
	try
	{
		if(factorial(x) > 120)
			GPIOD->BSRRL = 0x2000; // LED 2 ein
		else
			GPIOD->BSRRL = 0x8000; // LED 4 ein
	}
	catch(...)
	{
		GPIOD->BSRRL = 0x4000; // LED 3 ein
	}
    while(1);
}
